Subject: Re: bug#36171: 25.1; Emacs displays Hebrew text incorrectly

From: Raoul Comninos <[email-masked]>
Date: Thu, 13 Jun 2019 20:39:10 +0200

I have tried out several different fonts but there is no change to the 
problem.

I still see the circles. These can be turned off if I turn off 
auto-composition-mode. However, though the  circles then disappear, the 
vowels appear incorrectly placed. They are not as poorly placed as 
before, but still do not all properly align beneath the consonants. Some 
vowels are slightly off.

I added (add-to-list 'default-frame-alist '(font-backend xfthb)) to my 
.emacs file, but this made no difference.

Below is the information you requested.

\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

              position: 50 of 9235 (1%), column: 7
             character: ְ (displayed as ְ) (codepoint 1456, #o2660, #x5b0)
               charset: unicode-bmp (Unicode Basic Multilingual Plane 
(U+0000..U+FFFF))
code point in charset: 0x05B0
                script: hebrew
                syntax: w     which means: word
              category: ^:Combining
              to input: type "C-x 8 RET 5b0" or "C-x 8 RET HEBREW POINT 
SHEVA"
           buffer code: #xD6 #xB0
             file code: #xD6 #xB0 (encoded by coding system utf-8-unix)
               display: composed to form "ְ" (see below)

Composed using this font:
   xft:-unknown-DejaVu Sans-normal-normal-normal-*-26-*-*-*-*-0-iso10646-1
by these glyphs:
   [1 1 9676 3748 23 1 22 17 4 nil]
   [1 1 1456 1297 0 7 9 -1 6 nil]

Character code properties: customize what to show
   name: HEBREW POINT SHEVA
   general-category: Mn (Mark, Nonspacing)
   decomposition: (1456) ('ְ')

\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

              position: 41 of 9235 (0%), column: 0
             character: בּ‎ (displayed as בּ‎) (codepoint 64305, #o175461, 
#xfb31)
               charset: unicode-bmp (Unicode Basic Multilingual Plane 
(U+0000..U+FFFF))
code point in charset: 0xFB31
                script: hebrew
                syntax: w     which means: word
              category: .:Base, R:Right-to-left (strong)
              to input: type "C-x 8 RET fb31" or "C-x 8 RET HEBREW 
LETTER BET WITH DAGESH"
           buffer code: #xEF #xAC #xB1
             file code: #xEF #xAC #xB1 (encoded by coding system utf-8-unix)
               display: by this font (glyph code)
     xft:-unknown-DejaVu 
Sans-normal-normal-normal-*-26-*-*-*-*-0-iso10646-1 (#x13D1)

Character code properties: customize what to show
   name: HEBREW LETTER BET WITH DAGESH
   general-category: Lo (Letter, Other)
   decomposition: (1489 1468) ('ב' 'ּ')

There are text properties here:
   fontified            t

///////////////////////////////////////////////////////////////////////////////

On 2019/06/13 18:42, Eli Zaretskii wrote:
>> From: Robert Pluim <[email-masked]>
>> Cc: Raoul Comninos <[email-masked]>,  [email-masked]
>> Date: Thu, 13 Jun 2019 18:07:06 +0200
>>
>>      Eli> I don't see any such circles on my system.  I tried half a dozen
>>      Eli> different fonts, and they all work correctly.  How many fonts did you
>>      Eli> try?
>>
>> I see circles on my GNU/Linux box, but only when using the xft font
>> backend, eg the second character from the left (visually) on the
>> 'Aoristic perfect' line. If I put
>>
>> (add-to-list 'default-frame-alist '(font-backend xfthb))
>>
>> in my .emacs, then everything displays correctly.
> That's what I thought, thanks.  So these circles are a deficiency of
> FLT shaping.
>
>> I thought HarfBuzz was supposed to be preferred to xft?
> It's supposed to, but, disappointedly,
> https://lists.gnu.org/archive/html/emacs-devel/2019-06/msg00124.html
> remains without a response, and therefore only the Windows build
> currently prefers HarfBuzz.  I still hope Yamamoto-san will respond
> and describe his proposal, and we could then implement the same
> behavior on all platforms.